{% extends 'base.html' %}

{% block content %}
{% autoescape false %}
<div class="fr-col-12">
    <div class="fr-grid-row">
        <div class="fr-col-12 fr-col-lg-2">
            {% include 'content/side-nav.html' %}
        </div>

        <div class="fr-col-12 fr-col-lg-10">
            <section class="gn-main-content">
                <header class="fr-grid-row fr-grid-row--middle">
                    <h1 class="fr-h3">Mes contenus {% if currentCategoryName %} <br /><em class="fr-h6">{{ currentCategoryName }}</em> {% endif %}</h1>
                    <a href="{{ domain }}/contenus/nouveau" class="fr-btn fr-icon-add-circle-line fr-btn--icon-left">
                        Nouveau contenu
                    </a>
                </header>

                <div class="fr-tabs gn-tabs">
                    {% include 'content/contents-menu-tabs.html' %}

                    <div id="draft-contents" class="fr-tabs__panel fr-tabs__panel--selected" role="tabpanel"
                        aria-labelledby="draft-contents-tab" tabindex="0">
                        {% include 'content/contents-table.html' with {'tableId': 'draft-contents-table', 'tableDataAjax': 'ajaxRequestContents'} %}
                    </div>
                    <div id="to-publish-contents" class="fr-tabs__panel" role="tabpanel" aria-labelledby="to-publish-contents-tab" tabindex="0">
                        {% include 'content/contents-table.html' with {'tableId': 'to-publish-contents-table'} %}
                    </div>
                    <div id="published-contents" class="fr-tabs__panel" role="tabpanel" aria-labelledby="published-contents-tab" tabindex="0">
                        {% include 'content/contents-table.html' with {'tableId': 'published-contents-table'} %}
                    </div>
                    <div id="archived-contents" class="fr-tabs__panel" role="tabpanel" aria-labelledby="archived-contents-tab" tabindex="0">
                        {% include 'content/contents-table.html' with {'tableId': 'archived-contents-table'} %}
                    </div>
                    <div id="deleted-contents" class="fr-tabs__panel" role="tabpanel" aria-labelledby="deleted-contents-tab" tabindex="0">
                        {% include 'content/contents-table.html' with {'tableId': 'deleted-contents-table'} %}
                    </div>
                </div>

                {% include 'content/quick-access.html' %}

            </section>
        </div>
    </div>
</div>

{% include './modals/content/archive-content.html' %}
{% include './modals/content/duplicate-content.html' %}
{% include './modals/content/delete-content.html' %}
{% include './modals/content/share-content.html' %}

{% endautoescape %}
{% endblock %}

{% block script %}
{% autoescape false %}
{% include '/scripts/bootstrap-table-imports.html' %}

<script type="text/javascript">

    var csrfName = '{{ csrf.name }}';
    var csrfValue = '{{ csrf.value }}';

    function ajaxRequestContents(params) {
        $.ajax({
            url: '/action/ajax/list/contents',
            method: 'post',
            data: {
                csrf_name: csrfName,
                csrf_value: csrfValue,
                category: '{{ currentCategory  }}'
            },
            success: function (data) {
                params.success({
                    rows: data.draft.rows,
                    total: data.draft.total
                });
                $('#draft-contents-count').html(data.draft.total);

                $('#to-publish-contents-table').bootstrapTable('load', data.toPublish.rows);
                $('#to-publish-contents-count').html(data.toPublish.total);

                $('#published-contents-table').bootstrapTable('load', data.published.rows);
                $('#published-contents-count').html(data.published.total);

                $('#archived-contents-table').bootstrapTable('load', data.archived.rows);
                $('#archived-contents-count').html(data.archived.total);

                $('#deleted-contents-table').bootstrapTable('load', data.deleted.rows);
                $('#deleted-contents-count').html(data.deleted.total);
            },
            error: function (er) {
                params.error(er);
            },
        });
    }

    function dateFormatter(value, row, index) {
        var date = '-';
        if (value && value !== '' && value.date !== '') {
            date = value.date.substring(8, 10) + '/' + value.date.substring(5, 7) + '/' + value.date.substring(0, 4);
        }
        return [date].join('');
    }

    function priorityFormatter(value, row, index) {
        var priority = [];
        priority.push('<div class="gn-priority">');
        for (let i = 1; i < 5; i++) {
            if (value < i) {
                priority.push('<span class="fr-icon-star-line fr-icon--sm" aria-hidden="true"></span>');
            } else {
                priority.push('<span class="fr-icon-star-fill fr-icon--sm" aria-hidden="true"></span>');
            }
        }
        priority.push('</div>');

        return priority.join('');
    }

    function channelsFormatter(value, row, index) {
        var selectedChannels = [];
        var channels = [];
        var activeEmail, activeSms, activeWebsite = '';
        value.forEach(function(communicationChannel) {
            if (communicationChannel.channel === 'EMAIL') {
                activeEmail = 'gn-channels--active';
            } else if (communicationChannel.channel === 'SMS') {
                activeSms = 'gn-channels--active';
            } else if (communicationChannel.channel === 'WEBSITE') {
                activeWebsite = 'gn-channels--active';
            } else if (communicationChannel.channel === 'CHANNEL') {
                selectedChannels.push(communicationChannel.organisationChannel?.id);
            }
        });

        channels.push('<div class="gn-channels">');
        channels.push('<span class="fr-icon-mail-line fr-icon--sm ' + activeEmail + '" aria-hidden="true" title="Par email"></span>');
        channels.push('<span class="fr-icon-message-2-line fr-icon--sm ' + activeSms + '" aria-hidden="true" title="Par SMS"></span>');
        channels.push('<span class="fr-icon-window-fill fr-icon--sm ' + activeWebsite + '" aria-hidden="true" title="Sur site"></span>');

        {% for channel in organization.activeChannels %}
            channels.push('<span class="fr-icon-{{ channel|channelIcon }} fr-icon--sm ' + (
                selectedChannels.includes({{channel.id}}) ? 'gn-channels--active' : ''
            ) + '" aria-hidden="true" title="{{ channel.channelName }}"></span>');
        {% endfor %}

        channels.push('</div>');

        return channels.join('');
    }

    function authorFormatter(value, row, index) {
        var author = [];
        // TODO
        author.push('@' + row.creator.login);

        return author.join('');
    }

    function statusFormatter(value, row, index) {
        var status = [];

        if (value == 'TO_PUBLISH') {
            status = ['<span class="fr-badge fr-badge--green-emeraude fr-badge--no-icon">{{ constant("Multicanal\\Entity\\Enum\\ContentStatusType::TO_PUBLISH") }}</span>'];
        }
        else if (value == 'PUBLISHING') {
            status = ['<span class="fr-badge fr-badge--success fr-badge--no-icon">{{ constant("Multicanal\\Entity\\Enum\\ContentStatusType::PUBLISHING") }}</span>'];
        }
        else if (value == 'PUBLISHED') {
            status = ['<span class="fr-badge fr-badge--success fr-badge--no-icon">{{ constant("Multicanal\\Entity\\Enum\\ContentStatusType::PUBLISHED") }}</span>'];
        }
        else if (value == 'DRAFT') {
            status = ['<span class="fr-badge fr-badge--new fr-badge--no-icon">{{ constant("Multicanal\\Entity\\Enum\\ContentStatusType::DRAFT") }}</span>'];
        }
        else if (value == 'DELETED') {
            status = ['<span class="fr-badge fr-badge--error fr-badge--no-icon">{{ constant("Multicanal\\Entity\\Enum\\ContentStatusType::DELETED") }}</span>'];
        }
        else if (value == 'ARCHIVED') {
            status = ['<span class="fr-badge fr-badge--grey-425 fr-badge--no-icon">{{ constant("Multicanal\\Entity\\Enum\\ContentStatusType::ARCHIVED") }}</span>'];
        }

        return status.join('');
    }

    function operateFormatter(value, row, index) {
        var operate = [];
        operate.push('<div class="gn-actions">');
        if (row.status === 'DRAFT' || row.status === 'TO_PUBLISH') {
            operate.push('<button class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-fi-edit-line edit-content" title="&Eacute;diter">&Eacute;diter</button>');
        }
        if (row.channels.length > 0 && (row.status === 'TO_PUBLISH' || row.status === 'PUBLISHING')) {
            operate.push('<button class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-icon-send-plane-line publish-content" title="Publier">Publier</button>');
        }
        operate.push('<button class="fr-btn--sm fr-btn  fr-btn--tertiary-no-outline gn-icon-copy-file-line duplicate-content" title="Dupliquer">Dupliquer</button>');
        if (row.status !== 'ARCHIVED' && row.status !== 'DELETED') {
            operate.push('<button class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-icon-user-add-line share-content" title="Partager un contenu">Partager un contenu</button>');
            operate.push('<button class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-icon-archive-line archive-content" title="Archiver">Archiver</button>');
        }
        if (row.status !== 'DELETED' && row.status !== 'PUBLISHING') {
            operate.push('<button class="fr-btn fr-btn--sm fr-btn--tertiary-no-outline fr-fi-delete-line delete-content" title="Supprimer">Supprimer</button>');
        }

        operate.push('</div>')

        return operate.join('');
    }

    window.operateEvents = {
        'click button.edit-content': function (e, value, row, index) {
            window.location = '/contenus/modifier/' + row.id;
        },
        'click button.publish-content': function (e, value, row, index) {
            window.location = '/contenus/publier/' + row.id;
        },
        'click button.duplicate-content': function (e, value, row, index) {
            loadDuplicateContentModal(row.id, row.title);
        },
        'click button.share-content': function (e, value, row, index) {
            loadShareContentModal(row.id);
        },
        'click button.archive-content': function (e, value, row, index) {
            GN.openModal('archiveContentModal');
            $('#archiveContentModal input[name="content-id"]').val(row.id);
            $('#archiveContentModal span.content-name').html(row.title);
        },
        'click button.delete-content': function (e, value, row, index) {
            GN.openModal('deleteContentModal');
            $('#deleteContentModal input[name="content-id"]').val(row.id);
            $('#deleteContentModal span.content-name').html(row.title);
        }
    }

    function loadingTemplateContents(message) {
        return '<div class="text-center">Chargement des contenus en cours...<br /><div class="spinner-border mt-2" role="status"></div></div>';
    }
</script>

{% endautoescape %}
{% endblock %}
